#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct fnw {
    vector<int> a;
    void init(int n) {
        a.assign(n + 1, 0);
    }
    void modify(int i, int x) {
        for (++i; i < a.size(); i += i & -i) {
            a[i] += x;
        }
    }
    int kth(int k) {
        int x = 0;
        for (int i = 1 << __lg(a.size()); i > 0; i >>= 1) {
            if (x + i < a.size() && a[x + i] < k) {
                k -= a[x += i];
            }
        }
        return x;
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> h(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }

    fnw f;
    f.init(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        f.modify(i, 1);
    }

    vector<int> fa(n);
    iota(fa.begin(), fa.end(), 0);

    auto find = [&](int x) {
        while (x != fa[x]) {
            x = fa[x] = fa[fa[x]];
        }
        return x;
    };

    vector<deque<int>> d(n);
    vector<int> mx(h);
    vector<ll> sum(n);
    for (int i = 0; i < n; ++i) {
        d[i] = {i};
    }

    auto unite = [&](int l, int r) -> ll {
        l = find(l), r = find(r);
        // cout << "unite: " << l << " " << r << endl;
        // cout << d[l].size() << " " << d[r].size() << endl;
        assert(mx[l] == h[l]);
        assert(mx[r] == h[r]);
        ll add = 0;
        if (mx[l] > mx[r]) {
            while (d[r].front() != r) {
                add += (d[r][1] - d[r][0]) * (h[r] - h[d[r][0]]);
                d[r].pop_front();
            }
            while (h[d[l].back()] < h[r]) {
                add += (d[l].back() - d[l].rbegin()[1]) * (h[r] - h[d[l].back()]);
                d[l].pop_back();
            }
            if (d[r].size() > d[l].size()) {
                d[r].insert(d[r].begin(), d[l].begin(), d[l].end());
                d[l].clear();
                swap(d[l], d[r]);
            } else {
                d[l].insert(d[l].end(), d[r].begin(), d[r].end());
                d[r].clear();
            }
            fa[r] = l;
            sum[l] = sum[l] + sum[r] + add;
            return sum[l];
        } else {
            while (d[l].back() != l) {
                add += (d[l].back() - d[l].rbegin()[1]) * (h[l] - h[d[l].back()]);
                d[l].pop_back();
            }
            while (h[d[r].front()] < h[l]) {
                add += (d[r][1] - d[r][0]) * (h[l] - h[d[l].front()]);
                d[r].pop_front();
            }
            if (d[r].size() > d[r].size()) {
                d[r].insert(d[r].begin(), d[l].begin(), d[l].end());
                d[l].clear();
            } else {
                d[l].insert(d[l].end(), d[r].begin(), d[r].end());
                swap(d[l], d[r]);
                d[l].clear();
            }
            fa[l] = r;
            sum[r] = sum[l] + sum[r] + add;
            return sum[r];
        }
    };

    for (int i = 0; i < n - 1; ++i) {
        int x;
        cin >> x;
        int cut = f.kth(x);
        f.modify(cut, -1);
        // cout << cut << endl;
        cout << unite(cut, cut + 1) << '\n';
    }

    return 0;
}