#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int MOD = 1e9 + 7;

int msum(int x, int y) {
    return x + y < MOD ? x + y : x + y - MOD;
}

void madd(int &x, int y) {
    if ((x += y) >= MOD) {
        x -= MOD;
    }
}

constexpr int N_ = 1e6 + 7;

int fact[N_], ifact[N_], inum[N_];

void initF() {
    fact[0] = fact[1] = ifact[0] = ifact[1] = inum[1] = 1;
    for (int i = 2; i < N_; ++i) {
        fact[i] = 1LL * fact[i - 1] * i % MOD;
        inum[i] = 1LL * inum[MOD % i] * (MOD - MOD / i) % MOD;
        ifact[i] = ifact[i - 1] * 1LL * inum[i] % MOD;
    }
}

int choose(int n, int k) {
    return n < k || k < 0 ? 0 : 1LL * fact[n] * ifact[k] % MOD * ifact[n - k] % MOD;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    initF();

    int n, m, k;
    cin >> n >> m >> k;

    vector dp(n, vector(m, vector<int>(m)));
    vector<array<int, 2>> pts(k);
    vector nxt(n, vector<int>(m + 1, -1));
    for (auto &[x, y] : pts) {
        cin >> x >> y;
        x -= 1, y -= 1;
        nxt[x][y] = y;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            if (nxt[i][j] == -1 && j < m - 1) {
                nxt[i][j] = nxt[i][j + 1];
            }
        }
    }

    for (int init = 1; init < m; ++init) {
        if (nxt[0][init + 1] == -1) {
            dp[1][0][init] = 1;
        }
    }

    for (int i = 1; i < n - 1; ++i) {
        for (int d = 0; d < m; ++d) {
            for (int u = d + 1; u < m; ++u) {
                if (!dp[i][d][u]) {
                    continue;
                }
                // cout << i << " " << d << " " << u << endl;
                for (int nd = d; nd < u; ++nd) {
                    for (int nu = u; nu < m; ++nu) {
                        if ((nxt[i + 1][0] == -1 || nxt[i + 1][0] >= nd) && (nxt[i][nd + 1] == -1 || nxt[i][nd + 1] >= u)) {
                            if ((nxt[i][nu + 1] == -1)) {
                                madd(dp[i + 1][nd][nu], dp[i][d][u]);
                            }
                        }
                    }
                }
            }
        }
    }

    int ans = 0;
    for (int d = 0; d < m; ++d) {
        if (nxt[n - 1][0] == -1 || nxt[n - 1][0] >= d) {
            madd(ans, dp[n - 1][d][m - 1]);
        }
    }
    cout << msum(ans, ans) << '\n';

    return 0;
}